#  Pyrogram - Telegram MTProto API Client Library for Python
#  Copyright (C) 2017-present Dan <https://github.com/delivrance>
#
#  This file is part of Pyrogram.
#
#  Pyrogram is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published
#  by the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  Pyrogram is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with Pyrogram.  If not, see <http://www.gnu.org/licenses/>.

from io import BytesIO

from pyrogram.raw.core.primitives import Int, Long, Int128, Int256, Bool, Bytes, String, Double, Vector
from pyrogram.raw.core import TLObject
from pyrogram import raw
from typing import Optional, Any

# # # # # # # # # # # # # # # # # # # # # # # #
#               !!! WARNING !!!               #
#          This is a generated file!          #
# All changes made in this file will be lost! #
# # # # # # # # # # # # # # # # # # # # # # # #


class UpdateStarsRevenueStatus(TLObject):  # type: ignore
    """The Telegram Star balance of a channel/bot we own has changed ».

    Constructor of :obj:`~pyrogram.raw.base.Update`.

    Details:
        - Layer: ``203``
        - ID: ``A584B019``

    Parameters:
        peer (:obj:`Peer <pyrogram.raw.base.Peer>`):
            Channel/bot

        status (:obj:`StarsRevenueStatus <pyrogram.raw.base.StarsRevenueStatus>`):
            New Telegram Star balance.

    """

    __slots__: list[str] = ["peer", "status"]

    ID = 0xa584b019
    QUALNAME = "types.UpdateStarsRevenueStatus"

    def __init__(self, *, peer: "raw.base.Peer", status: "raw.base.StarsRevenueStatus") -> None:
        self.peer = peer  # Peer
        self.status = status  # StarsRevenueStatus

    @staticmethod
    def read(b: BytesIO, *args: Any) -> "UpdateStarsRevenueStatus":
        # No flags
        
        peer = TLObject.read(b)
        
        status = TLObject.read(b)
        
        return UpdateStarsRevenueStatus(peer=peer, status=status)

    def write(self, *args) -> bytes:
        b = BytesIO()
        b.write(Int(self.ID, False))

        # No flags
        
        b.write(self.peer.write())
        
        b.write(self.status.write())
        
        return b.getvalue()
